# general & negation short option tests
echo short general
if ! ./test1 -r | grep "recursion is on" > /dev/null; then exit 1; fi
echo short negation
if ! ./test1 +r | grep "recursion is off" > /dev/null; then exit 1; fi
echo short general-negation
if ! ./test1 -r +r | grep "recursion is off" > /dev/null; then exit 1; fi
echo short negation-general
if ! ./test1 +r -r | grep "recursion is on" > /dev/null; then exit 1; fi
# short option argument tests
echo short option-spaced
if ! ./test1 -d 10 | grep "depth is 10" > /dev/null; then exit 1; fi
echo short option-nospace
if ! ./test1 -d10 | grep "depth is 10" > /dev/null; then exit 1; fi
echo short option-nospace-spaced
if ! ./test1 -d 10 -d20 | grep "depth is 20" > /dev/null; then exit 1; fi
echo short option-sspaced-nospace
if ! ./test1 -d10 -d 20 | grep "depth is 20" > /dev/null; then exit 1; fi
# general & negation long option tests
echo long general
if ! ./test1 --recursive | grep "recursion is on" > /dev/null; then exit 1; fi
echo long negation
if ! ./test1 --no-recursive | grep "recursion is off" > /dev/null; then exit 1; fi
echo long general-negation
if ! ./test1 --recursive --no-recursive | grep "recursion is off" > /dev/null; then exit 1; fi
echo long negation-general
if ! ./test1 --no-recursive --recursive | grep "recursion is on" > /dev/null; then exit 1; fi
# long option argument tests
echo long option-equals
if ! ./test1 --depth=10 | grep "depth is 10" > /dev/null; then exit 1; fi
echo long option-spaced
if ! ./test1 --depth 10 | grep "depth is 10" > /dev/null; then exit 1; fi
echo long option-equals-spaced
if ! ./test1 --depth=10 --depth 20 | grep "depth is 20" > /dev/null; then exit 1; fi
echo long option-spaced-equals
if ! ./test1 --depth 10 --depth=20 | grep "depth is 20" > /dev/null; then exit 1; fi
# argument tests
echo arg 1
if ! ./test1 1 2 3 | grep "arg: 1" > /dev/null; then exit 1; fi
echo arg 2
if ! ./test1 1 2 3 | grep "arg: 2" > /dev/null; then exit 1; fi
echo arg 3
if ! ./test1 1 2 3 | grep "arg: 3" > /dev/null; then exit 1; fi
# doubledash argument tests
echo doubledash exitvalue
if ! ./test1 -- --depth 10 -h +r > /dev/null; then exit 1; fi
echo doubledash long
if ! ./test1 -- --depth 10 -h +r | grep "arg: --depth" > /dev/null; then exit 1; fi
echo doubledash number
if ! ./test1 -- --depth 10 -h +r | grep "arg: 10" > /dev/null; then exit 1; fi
echo doubledash short
if ! ./test1 -- --depth 10 -h +r | grep "arg: -h" > /dev/null; then exit 1; fi
echo doubledash negation
if ! ./test1 -- --depth 10 -h +r | grep "arg: +r" > /dev/null; then exit 1; fi
echo error-tests
#	unidentified flying option
echo error unidentified
if ./test1 -x > /dev/null 2>&1; then exit 1; fi
if ./test1 --xellotath > /dev/null 2>&1; then exit 1; fi
#	unwanted arg
echo error noarg
if ./test1 --recursive=plaa > /dev/null 2>&1; then exit 1; fi
#	mandatory arg missing
echo error argmissing
if ./test1 -d > /dev/null 2>&1; then exit 1; fi
#	syntax
echo error syntax
if ./test1 --=stuff > /dev/null 2>&1; then exit 1; fi
