#include <stdio.h>
#include <stdlib.h>
#include <frag-opt.h>

int main(int argc, char ** argv)
{
	int recursion = 0;
	char * depth = NULL;
	FRAG * frag;
	frag_option fops[] = {
/*	{ id short	"long-option"	TYPE		"argname"	"description" }	*/
	{ 0,		FRAG_PROGRAM,			"[FILES]",	"a program to show the "
	  "API and capabilities of frag-opt. let's test if the wrapper work here, too" },
	{ 1, 'h',	"help",		0,		NULL,		"print usage" },
	{ 2, 0,		"version",	0,		NULL,		"print version stuff" },
	{ 3, 'r',	"recursive",	FRAG_NEG,	NULL,		"enable recursive adding" },
	{ 4, 'd',	"depth",	FRAG_ARG,	"DEPTH",	"depth of recursion" },
	{ 5, 's',	"something-long-and-stupid", FRAG_NEG, NULL,	"something-long-and-stupid-blaadidaa-daa-duu-daa-hablablaa-hihaa-grendel-von-hunter-hellsing-von-herr ist ein stein" },
	{ FRAG_END_ARRAY }
	};

	frag = frag_init(fops, argc, argv, FRAG_DISABLE_LONG_OPTIONS
					 | FRAG_DISABLE_SHORT_OPTIONS
					 | FRAG_DISABLE_NEGATION_OPTIONS);
	if (frag == NULL) {
		printf("out of memory\n");
		exit(77);
	}
	while (frag_parse(frag)) {
		switch (frag->id) {
			case 0:
				printf("arg: %s\n", frag->arg);
				break;
			case 1:
				frag_usage(frag);
				frag_free(frag);
				exit(EXIT_SUCCESS);
				break;
			case 2:
				printf("example version 0.99.2\n");
				frag_free(frag);
				exit(EXIT_SUCCESS);
				break;
			case 3:
				recursion = frag->type;	/* "+r" == 0, "-r" == 1 */
				break;
			case 4:
				depth = frag->arg;
				break;
			case 5:
				printf("s %s\n", (frag->type ? "enabled": "disabled"));
				break;
			default:
				frag_free(frag);
				exit(EXIT_FAILURE);
		}
	}
	frag_free(frag);

	printf("recursion is %s, depth is %s\n",
			(recursion ? "on": "off"),
			(depth ? depth: "unset"));

	return 0;
}
