#include <stdio.h>
#include <stdlib.h>
#include <frag-opt.h>

/* for testing visibility control and merging descriptions */

int main(int argc, char **argv)
{
	int recursion = 0;
	char * depth = NULL;
	FRAG * frag;
	frag_option fops[] = {
/*	{ id short	"long-option"	TYPE		"argname"	"description" }	*/
	{ 0,		FRAG_PROGRAM,			"[FILES]",	"a program to show the "
	  "API and capabilities of frag-opt. let's test if the wrapper works here" },
	{ 1, 'h',	"help",		0,		NULL,		"print usage" },
	{ 1, 'u',	"usage",	FRAG_ALIAS,	NULL,		"ID918273645" },
	{ 1, 'm',	"moron",	FRAG_ALIAS,	NULL,		"ID192837465" },
	{ 2, 0,		"version",	0,		NULL,		"print version stuff" },
	{ 3, 'r',	"recursive",	FRAG_NEG,	NULL,		"enable recursive adding" },
	{ 4, 'd',	"depth",	FRAG_ARG,	"DEPTH",	"depth of recursion" },
	{ 5, 's',	"something-long-and-oh-so-stupid", FRAG_NEG, NULL, "testing 1 2 3... seems like the wrapper works fine. now something to identify this description. ID987654321" },
	{ 6, 'S',	"something-long-and-oh-so-much-more-stupid", FRAG_NEG | FRAG_HIDDEN, NULL,
	  "testing 1 2 3... seems like the wrapper works fine. now something to identify this description. ID123456789" },
	{ FRAG_END_ARRAY }
	};

	frag = frag_init(fops, argc, argv, FRAG_ENABLE_NO_SPACE_SHORT
					 | FRAG_ENABLE_SPACED_LONG);
	if (frag == NULL) {
		printf("out of memory\n");
		exit(77);
	}
	while (frag_parse(frag)) {
		switch (frag->id) {
			case 0:
				printf("arg: %s\n", frag->arg);
				break;
			case 1:
				frag_usage(frag);
				frag_free(frag);
				exit(EXIT_SUCCESS);
				break;
			case 2:
				printf("example version 0.99.2\n");
				frag_free(frag);
				exit(EXIT_SUCCESS);
				break;
			case 3:
				recursion = frag->type;	/* "+r" == 0, "-r" == 1 */
				break;
			case 4:
				depth = frag->arg;
				break;
			case 5:
				printf("s %s\n", (frag->type ? "enabled": "disabled"));
				break;
			case 6:
				printf("S %s\n", (frag->type ? "enabled": "disabled"));
				break;
			default:
				frag_free(frag);
				exit(EXIT_FAILURE);
		}
	}
	frag_free(frag);

	printf("recursion is %s, depth is %s\n",
			(recursion ? "on": "off"),
			(depth ? depth: "unset"));

	return 0;
}
